import request, { postBlob, getBlob, handleImport } from '@/utils/request'

export function adminDeptImport(data) {
  return handleImport('/admin/dept/import', data.formdata, data.id || '')
}

export function adminDeptList(data) {
  return request({
    url: `/admin/dept/list?moduleId=${data.moduleId}`,
    method: 'post',
    data
  })
}

export function adminDeptListExport(data, name) {
  return postBlob({
    url: '/admin/dept/list/export',
    data,
    name
  })
}

export function adminDeptTree(params) {
  return request({
    url: '/admin/dept/tree',
    method: 'get',
    params
  })
}

export function adminDeptAdd(data) {
  return request({
    url: '/admin/dept/add',
    method: 'post',
    data
  })
}

export function adminDeptUpdate(data) {
  return request({
    url: '/admin/dept/update',
    method: 'post',
    data
  })
}

export function adminDeptDel(params) {
  return request({
    url: '/admin/dept/del',
    method: 'post',
    params
  })
}

export function adminDeptAddWebsit(params) {
  return request({
    url: '/admin/dept/addWebsit',
    method: 'post',
    params
  })
}

export function adminDeptUpdateWebsit(data) {
  return request({
    url: '/admin/dept/updateWebsit',
    method: 'post',
    data
  })
}

export function adminDeptDelWebsit(params) {
  return request({
    url: '/admin/dept/delWebsit',
    method: 'post',
    params
  })
}

export function adminDeptTreeWebsit(params) {
  return request({
    url: '/admin/dept/treeWebsit',
    method: 'get',
    params
  })
}
